// Egyszer javtott buborkrendezs

#include <iostream>

using namespace std;

void kiir(int n, int x[]){

	for(int i = 1; i <= n; i++)
		cout << x[i] <<" ";
	cout << endl;
}

void csere(int & a, int & b){
	a ^= b ^= a ^= b;	
}

void javitottBuborekRendezes1(int n, int x[]){
	bool rendezett;
	int nn = n - 1;

	do{
		rendezett = true;

		for(int i = 1; i <= nn; i++){
			if(x[i] > x[i + 1]){
				csere(x[i], x[i + 1]);
				rendezett = false;
			}
		}

		nn--;

	}while(!rendezett);
}

int main(){
	cout << " - Javitott Bubble Sort 1 - \n\n";

	int x[] = {0, 5, 1, 45, 21, 100, 6, 30, 11, 4, 12};
	int n = 10;

	cout << "A sorozat: " << endl;
	kiir(n, x);
	cout<<endl;
	
	javitottBuborekRendezes1(n, x);

	cout << "A rendezett sorozat: " << endl;
	kiir(n, x);
}

