// Szmjegyes rendezs

#include <iostream>

using namespace std;

const int HATVANY10[] = {1, 10, 100, 1000, 10000, 100000, 1000000, 10000000, 100000000, 1000000000};

void kiir(int n, int x[]){
	for(int i = 1; i <= n; i++)
		cout << x[i] << " ";
	cout << endl;
}

void masol(int n, int x[], int y[]){
	for(int i = 1; i <= n; i++)
		y[i] = x[i];
}

int szamjegy(int szam, int szj){
	return (szam / HATVANY10[szj]) % 10; 
}

void RadixSort(int n, int x[], int rendezett[]){
	int k = 9;							// a rendezend szamok maximlis szmjegye
	int hany[20];// a hny tmb i-edik elemben egy adott szmjegynek megfelel "oszlop"-ban i-vel egyenl szmjegyek szmt troljuk. 
	// Ennek a tmbnek lesz -1-edik eleme is, amelyre akkor van szksg, amikor kiszmtjuk a 0-dik elemet.
	int minusz = 10;

	for(int szj = 0; szj <= k; szj++){
		for(int j = 0; j <= 9; j++)
			hany[j] = 0;
		hany[minusz] = 0;

		for(int i = 1; i <= n; i++){
			int melyik = szamjegy(x[i], szj);
			
			if(melyik == -1)
				hany[minusz]++;
			else
				hany[melyik]++;
		}

		hany[0] += hany[minusz];

		for(int i = 1; i <= 9; i++)
			hany[i] += hany[i - 1];

		for(int i = 1; i <= n; i++){
			int seged = szamjegy(x[i], szj);
			
			if(seged == 0)
				seged = 11;

			int hova = hany[seged - 1] + 1;
			rendezett[hova] = x[i];
			hany[seged - 1]++;
		}

		masol(n, rendezett, x);
	}
}

int main(){
	cout<<" - Szamjegyes Rendezes - \n\n";

	int x[] = {0, 2356700, 10023, 450, 876, 876, 3299881};
	int n = 6;
	
	cout << "A sorozat: " << endl;
	kiir(n, x);
	cout << endl;
    	
	int er[50];

	RadixSort(n, x, er);

	cout << "A rendezett sorozat: " << endl;
	kiir(n, x);
}
