// Buborékrendezés

#include <iostream>

using namespace std;

void kiir(int n, int x[]){

	for(int i = 1; i <= n; i++)
		cout << x[i] <<" ";
	cout << endl;
}

void csere(int & a, int & b){
	a ^= b ^= a ^= b;	// felcserélés a xor (kizáró vagy) alkalmazásával
}

void buborekRendezes(int n, int x[]){
	bool ok;

	do{
		ok = true;

		for(int i = 1; i < n; i++){
			if(x[i] > x[i + 1]){
				csere(x[i], x[i + 1]);
				ok = false;
			}
		}
	}while(!ok);
}

int main(){
	cout << " - Bubble Sort - \n\n";

	int x[] = {0, 5, 1, 45, 21, 100, 6, 99, 11, 4, 12};// a 0 indexű elemet figyelmen kívül hagyjuk a rendezéskor
	int n = 10;

	cout << "A sorozat: " << endl;
	kiir(n, x);
	cout << endl;
	
	buborekRendezes(n, x);

	cout << "Rendezve: " << endl;
	kiir(n, x);
	cout << endl;
}
